import 'package:fis_measure/interfaces/process/items/item.dart';
import 'package:fis_measure/interfaces/process/items/item_metas.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_ellipse_den_measure.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_ellipse_den_vel_measure.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_ellipse_density.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_ellipse_fractal_dim.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_ellipse_hist.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_ellipse_perfusion.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_ellipse_vel_measure.dart';
import 'package:fis_measure/process/primitives/ellipse.dart';

class URMEllipseMeasure extends Ellipse {
  URMEllipseMeasure(super.meta, super.parent);

  static URMEllipseMeasure createURMEllipseDenMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMEllipseMeasure measureEllipse = URMEllipseMeasure(meta, parent);
    measureEllipse.calculator = URMEllipseDenMeasureCal(
      measureEllipse,
    );
    return measureEllipse;
  }

  static URMEllipseMeasure createURMEllipseHist(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMEllipseMeasure measureHist = URMEllipseMeasure(meta, parent);
    measureHist.calculator = URMEllipseHistCal(
      measureHist,
    );
    return measureHist;
  }

  static URMEllipseMeasure createURMEllipseDenVelMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMEllipseMeasure measureEllipseDenVel = URMEllipseMeasure(meta, parent);
    measureEllipseDenVel.calculator = URMEllipseDenVelMeasureCal(
      measureEllipseDenVel,
    );
    return measureEllipseDenVel;
  }

  static URMEllipseMeasure createURMEllipseDensity(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMEllipseMeasure measureEllipseDensity = URMEllipseMeasure(meta, parent);
    measureEllipseDensity.calculator = URMEllipseDensityCal(
      measureEllipseDensity,
    );
    return measureEllipseDensity;
  }

  static URMEllipseMeasure createURMEllipseFractalDim(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMEllipseMeasure measureEllipseFractalDim =
        URMEllipseMeasure(meta, parent);
    measureEllipseFractalDim.calculator = URMEllipseFractalDimCal(
      measureEllipseFractalDim,
    );
    return measureEllipseFractalDim;
  }

  static URMEllipseMeasure createURMEllipseVelMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMEllipseMeasure measureEllipseVel = URMEllipseMeasure(meta, parent);
    measureEllipseVel.calculator = URMEllipseVelMeasureCal(
      measureEllipseVel,
    );

    return measureEllipseVel;
  }

  static URMEllipseMeasure createURMEllipsePerfusion(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMEllipseMeasure measureEllipsePerfusion = URMEllipseMeasure(meta, parent);
    measureEllipsePerfusion.calculator = URMEllipsePerfusionCal(
      measureEllipsePerfusion,
    );
    return measureEllipsePerfusion;
  }
}
